# bulk-resubmission.properties
# WARNING: defaults loaded from resource classpath:/defaults.properties

# override(s)
default.environment=debug
default.environment_dtp=test
default.home_folder=/var/local/sophia/${default.environment_dtp}/goal/codifica
log4j.configuration=${default.home_folder}/bulk-resubmission-log4j2.xml
#aws.credentials=${default.home_folder}/AwsCredentials.properties


# bulk resubmission
bulk_resubmission.locked=false
#bulk_resubmission.heartbeat=100000
bulk_resubmission.bind_port=4449
bulk_resubmission.run_timeout=2m30s
bulk_resubmission.polling_period=10s

bulk_resubmission.sqs.max_messages_per_run=10
bulk_resubmission.sqs.max_polling_duration=${bulk_resubmission.run_timeout}
bulk_resubmission.sqs.polling_period=${bulk_resubmission.polling_period}
bulk_resubmission.sqs.sender_name=bulk-resubmission
bulk_resubmission.sqs.service_bus_queue=${default.environment}_service_bus
bulk_resubmission.sqs.to_process_queue=${default.environment}_to_process_bulk_resubmission_ml
bulk_resubmission.sqs.started_queue=${default.environment}_started_bulk_resubmission_ml
bulk_resubmission.sqs.completed_queue=${default.environment}_completed_bulk_resubmission_ml
bulk_resubmission.sqs.failed_queue=${default.environment}_failed_bulk_resubmission_ml

bulk_resubmission.outbound_force=false

bulk_resubmission.sqs.update_index.to_process_queue=${default.environment}_to_process_update_index_ml
bulk_resubmission.sqs.update_index.completed_queue=${default.environment}_completed_update_index_ml
bulk_resubmission.sqs.update_index.failed_queue=${default.environment}_failed_update_index_ml

bulk_resubmission.sqs.ulisse_ipi_dump.to_process_queue=${default.environment}_to_process_ulisse_ipi_dump_ml
bulk_resubmission.sqs.ulisse_ipi_dump.completed_queue=${default.environment}_completed_ulisse_ipi_dump_ml
bulk_resubmission.sqs.ulisse_ipi_dump.failed_queue=${default.environment}_failed_ulisse_ipi_dump_ml

bulk_resubmission.sqs.royalty_scheme.to_process_queue=${default.environment}_to_process_schema_riparto_ml
bulk_resubmission.sqs.royalty_scheme.completed_queue=${default.environment}_completed_schema_riparto_ml
bulk_resubmission.sqs.royalty_scheme.failed_queue=${default.environment}_failed_schema_riparto_ml


# incoming sqs messages
bulk_resubmission.sql.update_completed_update_index=\
	update ML_RIPROCESSAMENTO \
	   set DATA_RICEZIONE_DOCUMENTAZIONE = CURRENT_TIMESTAMP() \
	 where UUID_RICHIESTA_DOCUMENTAZIONE = {updateIndexRequestUuid}

bulk_resubmission.sql.update_failed_update_index=\
	update ML_RIPROCESSAMENTO \
	   set UUID_RICHIESTA_DOCUMENTAZIONE = NULL \
	     , UUID_RICHIESTA_DOCUMENTAZIONE = NULL \
	 where UUID_RICHIESTA_DOCUMENTAZIONE = {updateIndexRequestUuid} \
	   and NUMERO_RICHIESTE_DOCUMENTAZIONE < 3

bulk_resubmission.sql.update_completed_ulisse_ipi_dump=\
	update ML_RIPROCESSAMENTO_PERIODO \
	   set DATA_RICEZIONE_SCHEMI = CURRENT_TIMESTAMP() \
	 where UUID_RICHIESTA_SCHEMI = {ulisseIpiDumpRequestUuid}

bulk_resubmission.sql.update_failed_ulisse_ipi_dump=\
	update ML_RIPROCESSAMENTO_PERIODO \
	   set DATA_RICHIESTA_SCHEMI = NULL \
	     , UUID_RICHIESTA_SCHEMI = NULL \
	 where UUID_RICHIESTA_SCHEMI = {ulisseIpiDumpRequestUuid} \
	   and NUMERO_RICHIESTE_SCHEMI < 3

bulk_resubmission.sql.update_completed_royalty_scheme=\
	update ML_RIPROCESSAMENTO_PERIODO \
	   set DATA_RICEZIONE_MINICUBO = CURRENT_TIMESTAMP() \
	 where UUID_RICHIESTA_MINICUBO = {royaltySchemeRequestUuid}

bulk_resubmission.sql.update_failed_royalty_scheme=\
	update ML_RIPROCESSAMENTO_PERIODO \
	   set DATA_RICHIESTA_MINICUBO = NULL \
	     , UUID_RICHIESTA_MINICUBO = NULL \
	 where UUID_RICHIESTA_MINICUBO = {royaltySchemeRequestUuid} \
	   and NUMERO_RICHIESTE_MINICUBO < 3

bulk_resubmission.sql.select_ready_to_start_periods=\
	select r.ID_ML_RIPROCESSAMENTO as resubmissionId \
	     , rp.ID_ML_RIPROCESSAMENTO_PERIODO as resubmissionPeriodId \
	     , DATE_FORMAT(rp.DATA_FINE_PERIODO, '%Y-%m-%d') as periodDateTo \
	  from ML_RIPROCESSAMENTO r, ML_RIPROCESSAMENTO_PERIODO rp \
	 where r.ID_ML_RIPROCESSAMENTO = rp.ID_ML_RIPROCESSAMENTO \
	   and r.DATA_RICEZIONE_DOCUMENTAZIONE is not null \
	   and rp.DATA_RICEZIONE_MINICUBO is not null \
	   and rp.DATA_AVVIO_LAVORAZIONE is null
	   
bulk_resubmission.sql.update_ready_to_start_reports=\
	update ML_REPORT \
	   set STATO = 'VALIDATO' \
	 where RIPROCESSAMENTO = {resubmissionId} \
	   and DATE_FORMAT(PERIODO_COMPETENZA_DATA_A, '%Y-%m-%d') = {periodDateTo}

bulk_resubmission.sql.update_ready_to_start_period=\
	update ML_RIPROCESSAMENTO_PERIODO \
	   set DATA_AVVIO_LAVORAZIONE = CURRENT_TIMESTAMP() \
	 where ID_ML_RIPROCESSAMENTO_PERIODO = {resubmissionPeriodId}
	  
# outgoing sqs messages

bulk_resubmission.sql.select_outgoing_update_index=\
	select ID_ML_RIPROCESSAMENTO as resubmissionId \
	  from ML_RIPROCESSAMENTO \
	 where DATA_RICHIESTA_DOCUMENTAZIONE is null \
	   and UUID_RICHIESTA_DOCUMENTAZIONE is null

bulk_resubmission.sql.update_outgoing_update_index=\
	update ML_RIPROCESSAMENTO \
	   set DATA_RICHIESTA_DOCUMENTAZIONE = CURRENT_TIMESTAMP() \
	     , UUID_RICHIESTA_DOCUMENTAZIONE = {updateIndexRequestUuid} \
	     , NUMERO_RICHIESTE_DOCUMENTAZIONE = NUMERO_RICHIESTE_DOCUMENTAZIONE + 1 \
	 where ID_ML_RIPROCESSAMENTO = {resubmissionId}

bulk_resubmission.sql.select_outgoing_ulisse_ipi_dump=\
	select ID_ML_RIPROCESSAMENTO as resubmissionId \
	     , ID_ML_RIPROCESSAMENTO_PERIODO as resubmissionPeriodId \
	     , DATE_FORMAT(DATA_FINE_PERIODO, '%Y-%m-%d') as periodDateTo \
	  from ML_RIPROCESSAMENTO_PERIODO \
	 where DATA_RICHIESTA_SCHEMI is null \
	   and UUID_RICHIESTA_SCHEMI is null

bulk_resubmission.sql.update_outgoing_ulisse_ipi_dump=\
	update ML_RIPROCESSAMENTO_PERIODO \
	   set DATA_RICHIESTA_SCHEMI = CURRENT_TIMESTAMP() \
	     , UUID_RICHIESTA_SCHEMI = {ulisseIpiDumpRequestUuid} \
	     , NUMERO_RICHIESTE_SCHEMI = NUMERO_RICHIESTE_SCHEMI + 1 \
	 where ID_ML_RIPROCESSAMENTO_PERIODO = {resubmissionPeriodId}

bulk_resubmission.sql.select_outgoing_royalty_scheme=\
	select ID_ML_RIPROCESSAMENTO as resubmissionId \
	     , ID_ML_RIPROCESSAMENTO_PERIODO as resubmissionPeriodId \
	     , DATE_FORMAT(DATA_FINE_PERIODO, '%Y-%m-%d') as periodDateTo \
	  from ML_RIPROCESSAMENTO_PERIODO \
	 where DATA_RICHIESTA_MINICUBO is null \
	   and UUID_RICHIESTA_MINICUBO is null \
	   and DATA_RICEZIONE_SCHEMI is not null

bulk_resubmission.sql.update_outgoing_royalty_scheme=\
	update ML_RIPROCESSAMENTO_PERIODO \
	   set DATA_RICHIESTA_MINICUBO = CURRENT_TIMESTAMP() \
	     , UUID_RICHIESTA_MINICUBO = {royaltySchemesRequestUuid} \
	     , NUMERO_RICHIESTE_MINICUBO = NUMERO_RICHIESTE_MINICUBO + 1 \
	 where ID_ML_RIPROCESSAMENTO_PERIODO = {resubmissionPeriodId}


# bulk resubmissions
bulk_resubmission.sql.select_still_running=\
	select ID_ML_RIPROCESSAMENTO as resubmissionId \
	     , ID_ML_RIPROCESSAMENTO_PERIODO as resubmissionPeriodId \
	  from ML_RIPROCESSAMENTO_PERIODO \
	 where DATA_AVVIO_LAVORAZIONE is null

bulk_resubmission.sql.insert_resubmission=\
	insert into ML_RIPROCESSAMENTO () values ()

bulk_resubmission.sql.update_resubmittable_reports=\
	update ML_REPORT \
	   set ATTIVO = 0 \
	 where ID_ML_REPORT = {id}

bulk_resubmission.sql.select_resubmittable_reports=\
	select ID_ML_REPORT as id \
	     , LICENZA as license \
	     , CODICE_LICENZIATARIO as licenseeCode \
	     , NOMINATIVO_LICENZIATARIO as licenseeName \
	     , SERVIZIO as service \
	     , ORIG_PERIODO_COMPETENZA as period \
	     , DATE_FORMAT(PERIODO_COMPETENZA_DATA_DA, '%Y-%m-%d') as periodDateFrom \
	     , DATE_FORMAT(PERIODO_COMPETENZA_DATA_A, '%Y-%m-%d') as periodDateTo \
	     , MOD_UTILIZZAZIONE as utilizationMode \
	     , MOD_FRUIZIONE as fruitionMode \
	     , IN_ABBONAMENTO as subscription \
	     , POSIZIONE_REPORT as reportUrl \
	     , IDENTIFICATIVO_REPORT as reportId \
	     , PROGRESSIVO_REPORT as reportSeq \
	     , STATO as status \
	     , USA_CODICE_OPERA as keepWorkCode \
	     , DATE_FORMAT(DATA_UPLOAD, '%Y-%m-%d %H:%i:%s') as uploadDateTime \
	     , POSIZIONE_REPORT_NORMALIZZATO as inputFileUrl \
	     , DATE_FORMAT(DATA_VALIDAZIONE, '%Y-%m-%d %H:%i:%s') as validationDateTime \
	     , VALIDAZIONE_RECORD_TOTALI as validationTotalRecords \
	     , VALIDAZIONE_RECORD_VALIDI as validationValidRecords \
	     , VALIDAZIONE_UTILIZZAZIONI_VALIDE as validationValidSales \
	     , ATTIVO as active \
	     , STATO_LOGICO as logicalStatus \
	     , SOGLIA_VALIDAZIONE as validationThreshold \
	     , DATE_FORMAT(DATA_NOTIFICA_VALIDAZIONE, '%Y-%m-%d %H:%i:%s') as validationMuleDateTime \
	     , INFO_NOTIFICA_VALIDAZIONE as validationMulePayload \
	  from ML_REPORT \
	 where ATTIVO = 1 \
	   and (VALIDAZIONE_RECORD_VALIDI / VALIDAZIONE_RECORD_TOTALI * 100.0) >= SOGLIA_VALIDAZIONE \
	   and RIPARTIZIONE is null

bulk_resubmission.sql.insert_resubmitted_report=\
	insert into ML_REPORT \
		( LICENZA \
		, CODICE_LICENZIATARIO \
		, NOMINATIVO_LICENZIATARIO \
		, SERVIZIO \
		, ORIG_PERIODO_COMPETENZA \
		, PERIODO_COMPETENZA_DATA_DA \
		, PERIODO_COMPETENZA_DATA_A \
		, MOD_UTILIZZAZIONE \
		, MOD_FRUIZIONE \
		, IN_ABBONAMENTO \
		, POSIZIONE_REPORT \
		, IDENTIFICATIVO_REPORT \
		, PROGRESSIVO_REPORT \
		, STATO \
		, USA_CODICE_OPERA \
		, DATA_UPLOAD \
		, POSIZIONE_REPORT_NORMALIZZATO \
		, DATA_VALIDAZIONE \
		, VALIDAZIONE_RECORD_TOTALI \
		, VALIDAZIONE_RECORD_VALIDI \
		, VALIDAZIONE_UTILIZZAZIONI_VALIDE \
		, ATTIVO \
		, STATO_LOGICO \
		, SOGLIA_VALIDAZIONE \
		, DATA_NOTIFICA_VALIDAZIONE \
		, INFO_NOTIFICA_VALIDAZIONE \
		, RIPROCESSAMENTO \
		, REPORT_PADRE \
		) values \
		( {license} \
		, {licenseeCode} \
		, {licenseeName} \
		, {service} \
		, {period} \
		, {periodDateFrom} \
		, {periodDateTo} \
		, {utilizationMode} \
		, {fruitionMode} \
		, {subscription} \
		, {reportUrl} \
		, {reportId} \
		, {reportSeq} \
		, 'DA_RIPROCESSARE' \
		, {keepWorkCode} \
		, {uploadDateTime} \
		, {inputFileUrl} \
		, {validationDateTime} \
		, {validationTotalRecords} \
		, {validationValidRecords} \
		, {validationValidSales} \
		, 1 \
		, 'LAVORABILE' \
		, {validationThreshold} \
		, {validationMuleDateTime} \
		, {validationMulePayload} \
		, {resubmissionId} \
		, {id} \
		)

bulk_resubmission.sql.select_resubmission_periods=\
	select distinct ORIG_PERIODO_COMPETENZA as period \
	     , DATE_FORMAT(PERIODO_COMPETENZA_DATA_A, '%Y-%m-%d') as periodDateTo \
	  from ML_REPORT \
	 where RIPROCESSAMENTO = {resubmissionId}

bulk_resubmission.sql.insert_resubmission_period=\
	insert into ML_RIPROCESSAMENTO_PERIODO \
		( ID_ML_RIPROCESSAMENTO \
		, PERIODO \
		, DATA_FINE_PERIODO \
		) values \
		( {resubmissionId} \
		, {period} \
		, {periodDateTo} \
		)




     